#include <w3c-libwww/WWWLib.h>
#include <w3c-libwww/WWWInit.h>
#include <w3c-libwww/WWWHTML.h>
#include "qclear.h"

/* mailman  list member only mode ϶, ׿ִ spam  ִ α׷ .*/

int last_number = 0;
HTAssocList * formfields = NULL;

PRIVATE int printer (const char * fmt, va_list pArgs)
{
/*    return  (vfprintf(stdout, fmt, pArgs)); */
    return TRUE ;
}

PRIVATE int tracer (const char * fmt, va_list pArgs)
{
/*    return  (vfprintf(stderr, fmt, pArgs)); */
    return TRUE ;
}

PRIVATE int terminate_handler (HTRequest * request, HTResponse * response,
			       void * param, int status) 
{
    
    HTEventList_stopLoop ();

    return HT_OK; /* stop */
}


PRIVATE void GetNumber (HText * text, int element_number, const BOOL * present, const char **	value)
{
    SGML_dtd * dtd = HTML_dtd();
    HTTag * tag = SGML_findTag(dtd, element_number);

    if (tag) {
	int n = 0;
	int check = 0;
	char * tagname = HTTag_name(tag);
	int maxcnt = HTTag_attributes(tag);
	int cnt;
	/* input tag  , type  radio ΰ . */
	if ( tagname && strcmp ( tagname , "INPUT" ) == 0 )
	{
	    for (cnt=0; cnt<maxcnt; cnt++) {
		if (present[cnt]) {
		    char * attrname = HTTag_attributeName(tag, cnt);
		    if ( attrname && (strcmp ( attrname , "NAME" ) == 0 ) )
		    {
			n = strtol ( value[cnt] , NULL , 10 );
			check = 1;
		    }
		    if ( check && ( strcmp ( attrname , "TYPE" ) == 0 ) )
		    {
			if ( strcmp ( value[cnt] , "RADIO" ) == 0 && last_number != n )
			{
			    
			    char string[100];
			    
			    memset ( string , 0 , sizeof ( string ) );
			    last_number = n;
			    sprintf ( string , "%d=%d" , n , DISCARD_NUMBER );
			    HTParseFormInput(formfields, string );
			    printf ( "process ----- number %d\n" , n );
			}
		    }
		}
	    }
	}
    }

}

int clear_db( char *url , char *passwd )
{
    HTRequest * request = NULL;
    HTAnchor * anchor = NULL;   
    char* uri = NULL;
    char string[100];

    last_number = 0;

    memset ( string , 0 , sizeof ( string ));
    sprintf ( string , "adminpw=%s" , passwd );

    if ( !formfields )
	formfields = HTAssocList_new();

    /* Need our own trace and print functions */
    HTPrint_setCallback(printer);
    HTTrace_setCallback(tracer);

    
    HTParseFormInput(formfields, string );

    /* Create a new premptive client */
    HTProfile_newHTMLNoCacheClient ("MSIE", "5.5");

    /* Add our own filter to update the history list */
    HTNet_addAfter(terminate_handler, NULL, NULL, HT_ALL, HT_FILTER_LAST);

    /* Set the timeout for long we are going to wait for a response */
    HTHost_setEventTimeout(RESPONSE_WAIT);

    HText_registerElementCallback( GetNumber , NULL);    

    /* Create a request */
    request =  HTRequest_new();

    /* Get an anchor object for the URI */
    anchor = HTAnchor_findAddress(url);
    
    HTPostFormAnchor( formfields , anchor , request );

    /* Clean up the form fields */
    HTAssocList_delete(formfields);
    formfields = HTAssocList_new();

    /* Go into the event loop... */
    HTEventList_loop(request);

    return last_number;
}

int main ( int argc , char *argv[] )
{
    /* argv[1] is mailing name 
       argv[2] is passwd */

    char url[200];
    int ret = 0;

    if ( argc < 2 ) 
    {
	printf("qclear mailingname passwd\n");
	exit(1);
    }
    memset ( url , 0 , sizeof ( url ) );
    sprintf ( url , "%s%s" , BASE_URL , argv[1] );
    do 
    {
	ret = clear_db ( url , argv[2] );
    } while ( ret != 0 );

    if ( formfields )
	HTAssocList_delete(formfields);

    exit (1);
}



